import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class DataCaptureFilter extends EffectFilter
{	
	protected boolean needsCapture;

	public DataCaptureFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		needsCapture = false;
		dead = false;
		filterName = "Data Capture " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 150;
		guiY = 150;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
			
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		JPanel foo = new JPanel();
		JButton loadButton = new JButton("Capture Data");
		loadButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				// must be a button press
				needsCapture = true;
			}
		});
		foo.add(loadButton);
		
		guiWindow.add(foo);
		
		guiWindow.setVisible(true);
	}
	
	public void prepareForSave()
	{
		guiWidth = guiWindow.getWidth();
		guiHeight = guiWindow.getHeight();
		guiX = guiWindow.getX();
		guiY = guiWindow.getY();
	}
	
	public String getOutputName(int outputNum)
	{
		return "ImageOut";
	}
	
	public String getInputName(int inputNum)
	{
		return "ImageIn";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public void update(long dt)
	{
		needsProcessing = true;
		// do nothing...
	}
	
	public FloatImage getOutput(int outputChannel)
	{
		if(needsProcessing && filterInputs[0] != null)
		{
			if(needsCapture)
			{
				FloatImage temp = filterInputs[0].getOutput();
				
				if(temp != null)
					internalBuffer = temp.duplicate();
					
				needsCapture = false;
			}
			needsProcessing = false;
		}

		return internalBuffer;
	}	
}