public class FTriple
{
	public double[] val;
	
	public FTriple(double x, double y, double z)
	{
		val = new double[3];
		val[0] = x;
		val[1] = y;
		val[2] = z;
	}
	
	public FTriple(FTriple src)
	{
		val = new double[3];
		val[0] = src.val[0];
		val[1] = src.val[1];
		val[2] = src.val[2];
	}
	
	public String toString()
	{
		return "(" + val[0] + ", " + val[1] + ", " + val[2] + ")";
	}
	
	public FTriple plus(FTriple rhs)
	{
		return new FTriple(val[0] + rhs.val[0], val[1] + rhs.val[1], val[2] + rhs.val[2]);
	}
	
	public FTriple crossProduct(FTriple rhs)
	{
		double i, j, k;
		
		i = val[1] * rhs.val[2] - val[2] * rhs.val[1];
		j = val[2] * rhs.val[0] - val[0] * rhs.val[2];
		k = val[0] * rhs.val[1] - val[1] * rhs.val[0];
		
		return new FTriple(i, j, k);
	}
	
	public FTriple minus(FTriple rhs)
	{
		return new FTriple(val[0] - rhs.val[0], val[1] - rhs.val[1], val[2] - rhs.val[2]);
	}
	
	public FTriple times(double s)
	{
		return new FTriple(val[0] * s, val[1] * s, val[2] * s);
	}
	
	public double dotProduct(FTriple rhs)
	{
		return val[0]*rhs.val[0] + val[1]*rhs.val[1] + val[2]*rhs.val[2];
	}
	
	public FTriple norm()
	{
		float length = (float)(Math.sqrt(dotProduct(this)));
		return new FTriple(val[0]/length, val[1]/length, val[2]/length);
	}
}