import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class HistogramCalculatorFilter extends EffectFilter
{	
	public static final int NUM_BINS = 200;

	public HistogramCalculatorFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "Histogram Calculator " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage(3, NUM_BINS, 1);
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Histogram Calculator"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input";
	}
	
	public String getOutputName(int outputNum)
	{
		return "DATA: Histogram Out";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{
		if(internalBuffer == null || internalBuffer.getWidth() != NUM_BINS)
			internalBuffer = new FloatImage(3, NUM_BINS, 1);
			
		if(needsProcessing && filterInputs[0] != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				HistogramUtils.calculateHistogram(temp, internalBuffer);
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}