import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class HistogramDrawFilter extends EffectFilter
{	
	public static final int HIST_WIDTH 	= 200;
	public static final int HIST_HEIGHT = 300;

	public HistogramDrawFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "Histogram Drawer " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage(3, HIST_WIDTH, HIST_HEIGHT);
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Histogram Drawer"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input";
	}
	
	public String getOutputName(int outputNum)
	{
		return "Image Out";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{
		if(internalBuffer == null || internalBuffer.getWidth() != HIST_WIDTH ||
			internalBuffer.getHeight() != HIST_HEIGHT)
			internalBuffer = new FloatImage(3, HIST_WIDTH, HIST_HEIGHT);
			
		if(needsProcessing && filterInputs[0] != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				HistogramUtils.drawHistogram(temp, internalBuffer);
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}