import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class NoteFilter extends EffectFilter
{	
	private transient JTextArea noteTextArea;
	private String noteText;

	public NoteFilter()
	{
		filterInputs = new FilterLink[0];
		dead = false;
		filterName =  "Note" + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 150;
		guiY = 150;
		
		noteText = "Put your note here...";
		
		rebuildFromSave();
	}
	
	public void prepareForSave()
	{
		super.prepareForSave();
		noteText = noteTextArea.getText();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = null;
		needsProcessing = false;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		noteTextArea = new JTextArea();
		noteTextArea.setEditable(true);
		noteTextArea.setText(noteText);
		
		guiWindow.add(noteTextArea);
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input " + inputNum;
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 0;
	}
	
	public FloatImage getOutput(int outputChannel)
	{
		return null;
	}	
}