import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class ServoControlFilter extends EffectFilter
{	
	public ServoControlFilter()
	{
		filterInputs = new FilterLink[3];
		filterInputs[0] = null;
		filterInputs[1] = null;
		filterInputs[2] = null;
		dead = false;
		filterName = "Servo Control " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 100;
		guiY = 100;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{	
		internalBuffer = null;
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Servo Control"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		if(inputNum == 0)
			return "DATA: Servo 1 in";
		else if(inputNum == 1)
			return "DATA: Servo 2 in";
		else
			return "DATA: Servo 3 in";
	}
	
	public String getOutputName(int outputNum)
	{
		return "NONE";
	}
	
	public void update(long dt)
	{
		if(filterInputs != null)
		{
			ServoControl theController = ServoControl.getInstance();
			
			double servoPos;
			
			for(int i = 0; i < 3; ++i)
			{
				if(filterInputs[i] != null)
				{
					servoPos = filterInputs[i].getOutput().getChannelData(0)[0][0];
					
					theController.setServo(i+1, servoPos);
				}
			}
		}
	}
}