import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SimpleFireFilter extends EffectFilter
{
	private FloatImage fireColors;
	private FloatImage coolingImage;
	private transient SimpleFire theFire;
		
	public SimpleFireFilter()
	{
		filterInputs = new FilterLink[3];
		filterInputs[0] = null;
		filterInputs[1] = null;
		filterInputs[2] = null;
		dead = false;
		filterName = "Fire Effect " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
		coolingImage = new FloatImage();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		fireColors = new FloatImage();
		theFire = new SimpleFire();
		theFire.setCoolingField(coolingImage);
		
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);

		JPanel foo = new JPanel();
		
		JButton colorsButton = new JButton("Capture Colors");
		colorsButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				// must be a button press
				doColorCapture();
			}
		});
		foo.add(colorsButton);
		
		JButton coolingButton = new JButton("Capture Cooling");
		coolingButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				// must be a button press
				doCoolingCapture();
			}
		});
		foo.add(coolingButton);
		
		guiWindow.add(foo);
		
		guiWindow.setVisible(true);
	}
	
	public void doColorCapture()
	{
		if(filterInputs[2] != null)
		{
			FloatImage temp = filterInputs[2].getOutput();
			if(temp != null)
				fireColors = temp.duplicate();
		}
	}
	
	public void doCoolingCapture()
	{
		if(filterInputs[1] != null)
		{
			FloatImage temp = filterInputs[1].getOutput();
			if(temp != null)
			{
				coolingImage = temp.duplicate();
				theFire.setCoolingField(coolingImage);
			}
		}
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		switch(inputNum)
		{
		case 0:
			return "HotSpot in";
		case 1:
			return "Cooling in";
		case 2:
			return "Colors in";
		default:
			return "input";
		}
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null && theFire != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				double[][] red = temp.getChannelData(0);
				
				theFire.setHotSpots(red);
				theFire.updateFire();
				internalBuffer = theFire.getFireImage(fireColors);
			}
			
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}