import sys
import math
from Tkinter import *

def writeStringToFile(toWrite, filename):
    f = open(filename, "w")
    try:
        f.write(toWrite)
        f.close()
    except:
        print "some sort of error in writing to file"

def appendStringToFile(toAppend, filename):
    whatWasInFile = ""
    f = open(filename, "r")
    try:
        whatWasInFile += f.read()
#        print len(whatWasInFile)
        if len(whatWasInFile) > 0:
            whatWasInFile += "\n"
        f.close()
    except:
        print "error reading "+filename

    toWrite = whatWasInFile + toAppend
    writeStringToFile(toWrite, filename)

def readStringFromFile(filename):
    whatWasInFile = ""
    f = open(filename, "r")
    try:
        whatWasInFile += f.read()
#        print len(whatWasInFile)
        if len(whatWasInFile) > 0:
            whatWasInFile += "\n"
        f.close()
    except:
        print "error reading "+filename

    return whatWasInFile

def drawAStar():
        writeStringToFile("", "star.rob")
        for i in range(5):
            [x1, y1] = polarToCartesian(150, i * math.pi / 5.0 * 2.0)
            [x2, y2] = polarToCartesian(150, (i+2) * math.pi / 5.0 * 2.0)
            appendStringToFile(("%d\t%d\t%d\t%d" % (x1+200, y1+200, x2+200, y2+200)), "star.rob")
                
def polarToCartesian(r, theta):
        return [r * math.cos(theta), r * math.sin(theta)]

#drawAStar()
#sys.exit(0)


class MyApp:
    def __init__(self, parent):
        self.myParent = parent
        self.startingLine = True
        self.color = 0

        self.toWrite = ""
        self.filename = "pic01.rob"

        self.canv = Canvas(root, width=400, height = 400)
        self.canv.pack()

        self.canv.bind("<Button-3>", self.b3Down)
        self.canv.bind("<ButtonRelease-1>", self.b1Up)
        self.canv.bind("<B1-Motion>", self.paint)

        writeStringToFile("", self.filename)

    def showPicture(self, filename):
        theString = readStringFromFile(filename)
        lines = theString.split("\n")
        for line in lines:
            line = line.split("\t")
            for ele in line:
                ele = int(ele)
        canv.create_line(line[0], line[1], line[2], line[3])
        return theString

    def paint(self, event):
        x1, y1 = ( event.x - 4 ), ( event.y - 4 )
        x2, y2 = ( event.x + 4 ), ( event.y + 4 )

        toColor = self.color + 1
        if self.startingLine:
            print "new one"
            self.startingLine = False
            toColor = 0
            
        appendStringToFile(("%f %f %d" % \
         (event.x/400.0, 1.0-event.y/400.0, toColor)), self.filename)

        if self.color == 0:
            self.canv.create_oval( x1, y1, x2, y2, fill = "red" )
        if self.color == 1:
            self.canv.create_oval( x1, y1, x2, y2, fill = "blue" )

    def b1Up(self, event):
        self.startingLine = True

    def b3Down(self, event):
        self.color = (self.color + 1) % 2
#        print self.color

root = Tk()
myapp = MyApp(root)

root.mainloop()



